function Node(id, pid, name, url, title, target, icon, iconOpen, statusIcon, bgIcon, open, parallel,stageName) {

	this.id = id;
	this.pid = pid;
	this.name = name;
	this.url = url;
	this.title = title;
	this.target = target;
	this.icon = icon;
	this.iconOpen = iconOpen;
	this.statusIcon = statusIcon;
	this._io = open || false;
	this._is = false; 
	this._ls = false; 
	this._hc = false; 
	this._hsc = false; 
	this._ai = 0;
	this._p;            
	this._children = 0; 
	this._isLeft =  false; 
	this._isRight = false; 
	this._isOnly = false;  
	this._nodeIndex = 0; 
	this.parallel = parallel;
	this.visible = true; 
	this.bgIcon = bgIcon;
	this.stageName = stageName;
};


function dTree(objName, appContextPath) {
	this.config = {
		target			: null,
		folderLinks		: false,
		useSelection	: true,
		useCookies		: false,
		useLines		: true,
		useIcons		: true,
		useStatusText	: true,
		closeSameLevel	: false,
		inOrder			: false,
		showExpandCollapseIcon : false,
		showStageBorders : true,
		showStartEndIcons : true,
                selectMemberButtonId : "",
                openGroupButtonId : "",
                appContextPath : appContextPath
	};


	this.icon = {
		root			: appContextPath+'/images/root.png',
		folder			: appContextPath+'/images/folder.gif',
		folderOpen		: appContextPath+'/images/folderopen.gif',
		node			: appContextPath+'/images/page.gif',
		empty			: appContextPath+'/images/empty.gif',
		line			: appContextPath+'/images/myline2.png',
		join			: appContextPath+'/images/join.png',
		joinBottom		: appContextPath+'/images/joinbottom.png',
		plus			: appContextPath+'/images/plus.gif',
		plusBottom		: appContextPath+'/images/plusbottom.gif',
		minus			: appContextPath+'/images/minus.gif',
		minusBottom		: appContextPath+'/images/minusbottom.gif',
		nlPlus			: appContextPath+'/images/nolines_plus.gif',
		nlMinus			: appContextPath+'/images/nolines_minus.gif',
		middleLine		: appContextPath+'/images/middle_line.png',
		leftLine		: appContextPath+'/images/left_line.png',
		smallLine		: appContextPath+'/images/smallLine.png',
		rightLine		: appContextPath+'/images/right_line.png',
		treeStart               : appContextPath+'/images/taskstart_dia.png',
                treeend         : appContextPath+'/images/taskend_dia.png'
	};


	this.obj = objName;
	this.aNodes = [];
	this.aIndent = [];
	this.root = new Node(-1,-1,'','','','',this.icon.root,this.icon.root,'','',true,'true','');
	this.selectedNode = null;
	this.selectedFound = false;
	this.completed = false;
};




dTree.prototype.add = function(id, pid, name, url, title, target, icon, iconOpen, statusIcon, bgIcon, open, parallel, stageName) {
	this.aNodes[this.aNodes.length] = new Node(id, pid, name, url, title, target, icon, iconOpen, statusIcon, bgIcon, open, parallel, stageName);
};


dTree.prototype.openAll = function() {
	this.oAll(true);
};

dTree.prototype.closeAll = function() {
	this.oAll(false);
};


dTree.prototype.toString = function() {
	var str = '<div style="border:0">\n';
	if (document.getElementById) {
 	    if(this.config.showStartEndIcons && !this.root._hc) {
			str += '<div align = "center" class="dTreeNode" style="white-space:nowrap;padding: 0 0 0 0">';
			str += '<img src="'+this.icon.treeStart+'"/><div>';
			str += '<div align = "center" class="dTreeNode" style="white-space:nowrap;padding: 0 0 0 0">';
			str += '<img src="'+this.icon.line+'"/></div>';
		}
		if (this.config.useCookies) this.selectedNode = this.getSelected();
		str += this.addNode(this.root);
		if(this.config.showStartEndIcons && !this.root._hc) {
			str += '<div align = "center" class="dTreeNode" style="white-space:nowrap;padding: 0 0 0 0">';
			str += '<img  src="'+this.icon.treeend+'"/></div>';
		}
	} else str += 'Browser not supported.';
	str += '</div>';
	if (!this.selectedFound) this.selectedNode = null;
	this.completed = true;
	return str;
};


dTree.prototype.addNode = function(pNode)
{
	var str = '';
	if(this.config.showStartEndIcons) {
	    str += '<table cellpadding=0 cellspacing=0 border=0 width="100%">';
	}
	else {
	    str += '<table cellpadding=0 cellspacing=0 border=0 width="100%">';
	}
	str += '	<tr> ';
	var n=0;


	if (this.config.inOrder) n = pNode._ai;
	

	var childsIndex =0;
	var serialChildFound = false;

	for (n; n<this.aNodes.length; n++)
	{


		if (this.aNodes[n].pid == pNode.id)
		{
			var cn = this.aNodes[n];
			cn._p = pNode;

			cn._ai = n;

			this.setCS(cn); 
			cn._childIndex = childsIndex++;

			if(cn._p._children <= 1) {
				cn._isOnly = true;
			}
			else
			{
				var j = n+1;
				
				for(j; j < this.aNodes.length; j++) {
					if(this.aNodes[j].pid == pNode.id) {
						var ln = this.aNodes[j];
						if(ln.parallel == 'false') {
							serialChildFound = true;
							pNode._hsc = true;
						}
					}
				}
				
				if(cn._childIndex == 0)
					cn._isLeft=true;
				if(!serialChildFound) {
					if(cn._childIndex == cn._p._children-1) {
						cn._isRight=true;
					}
				}
				else {
					if(cn._childIndex == cn._p._children-2) {
						cn._isRight=true;
					}
					else if(cn._childIndex == cn._p._children-1) {
						cn._isOnly=true;
					}
				}

			}

			if (!cn.target && this.config.target) cn.target = this.config.target;
			if (cn._hc && !cn._io && this.config.useCookies) cn._io = this.isOpen(cn.id);
			if (!this.config.folderLinks && cn._hc) cn.url = null;
			if (this.config.useSelection && cn.id == this.selectedNode && !this.selectedFound) {
					cn._is = true;
					this.selectedNode = n;
					this.selectedFound = true;
			}
			if(cn.parallel == 'true') {
				if((pNode._hsc || !pNode.visible) && cn._isLeft) {
					str += '	<td valign=top align=center>';
				}
				else if((pNode._hsc || !pNode.visible) && cn._isRight) {
					str += '	<td valign=top align=center>';
				}
				else if((pNode._hsc || !pNode.visible) && !cn._isLeft && !cn._isRight) {
					str += '	<td valign=top align=center>';
				}
				else {
					str += '	<td valign=top align=center>';
				}
				str += this.node(cn, n);
				str += '	</td>';
			}
			else {
				serialChildFound = true;
				str += '</tr>';
				str += '<tr>';
				str += '<td valign=top align=center colspan=';
				str += cn._p._children -1;
				str += '>';
				str += this.node(cn, n);
				str += '</td>';
				str += '</tr>';
			}
			if(cn.id > -1 && cn._p._children == 0) {
			  str += ' <tr> <td align=center valign=top> <img src="'+this.icon.line+'"/> </td> </tr>';
			}
			

			if (cn._ls) break;
		}


	}
	
	str += ' </tr> </table>';

	

	return str;

};


dTree.prototype.node = function(node, nodeId) {
	var str = '';
	
	if(node._p._children <= 1)

		node._isOnly=true;

	

	if(node.id > -1 && node.pid == -1) {
		if(this.config.showStageBorders) {
			str = '<div class="dTreeNode" style="white-space:nowrap;border:1px dashed gray;padding: 0 10 10 10">';
			str += '<div class="approvertext" align="left">'+node.stageName+'</div>';
		}
		else {
			str = '<div class="dTreeNode" style="white-space:nowrap">';
		}
		if(node.target != '') {
			str += '<table border="0" cellpadding="0" cellspacing="0" width="100%">';
			str += '<tr> <td>';
			str += '<table border=0 cellpadding="2" width="20%" style="white-space:nowrap;border:1px dashed gray">';
			str += '<tr> <td>';
			str +=  node.target;
			str += '</td> </tr> </table> </td> </tr> </table>';
		}
	}
	else {
		str = '<div class="dTreeNode" style="white-space:nowrap;">';
	}
	if(node.parallel == 'true') {
	str += '<table border="0" cellpadding="0" cellspacing="0" width="100%" >';
	if(node._p.visible) {
	str += '<tr>';

	str += '	<td align="center" width="49%"'

	
	if (this.root.id != node.pid)
	{
		if(this.config.useLines)
		{
			if(node._isOnly)
			{
				str += '';
			}
			else if(node._isLeft)
			{
				str += '';
			}
			else if(node._isRight)
			{
				str += ' style="border-top-width:1px;border-top-style:solid;border-top-color:black;" ';
			}
			else
			{
				str += ' style="border-top-width:1px;border-top-style:solid;border-top-color:black;" ';
			}
		}
	}
	str += ' >&nbsp; ';
	str += '	</td>';

	str += '	<td valign="top" halign="center" width="1%"';

	str += ' >';

	if (this.root.id != node.pid) 
	{
		str += '<img src="';
		if(this.config.useLines)
		{
			if(node._isOnly)
				str += this.icon.line
			else if(node._isLeft)
				str += this.icon.leftLine;
			else if(node._isRight)
				str += this.icon.rightLine;
			else
				str += this.icon.middleLine;
		}
		else
		{
			str += this.icon.empty
		}
		str += '" alt="" />';
	}





	str += '	</td>';
	str += '	<td align="center" width="49%"';

	if (this.root.id != node.pid)
	{
		if(this.config.useLines)
		{
			if(node._isOnly)
				str += ' ';
			else if(node._isLeft)
				str += ' style="border-top-width:1px;border-top-style:solid;border-top-color:black;" ';
			else if(node._isRight)
				str += '';
			else
				str += ' style="border-top-width:1px;border-top-style:solid;border-top-color:black;" ';
		}
	}

	str += ' >&nbsp; ';
	str += '	</td>';
	str += '</tr>';

	
       if(node.name != 'WF_DUMMY_NODE'){
	str += '<tr height="24">';
	str += '	<td align="center" valign="top" height="24" colspan="3">';
  if(node.bgIcon == ''){
	    str += '<div style=" width:171px; height:24px; overflow:auto;">';
		str += node.name ;
		str += '</div>'
	   }else{
        str += '<div ';
        str += 'style="align:left; position:absolute; border:solid 1px black; background-color:#FFFFCC; padding:4px; display:none" ';
	str += 'id="tt' +this.obj + nodeId + '_reason">';
	str += node.title;
	str += '</div>';
	str += '<table name="appGroupMember" border=0 cellpadding="0" cellspacing="0" width="171" height="24" background="';
	str += node.bgIcon;
	str += '" style="background-repeat:no-repeat;background-position:center" class="approvertext" ';
	str += 'onmouseover="displayToolTip(this,\'tt'+this.obj+nodeId+'_reason\',171,24)"';
	str += 'onmouseout="hideToolTip(\'tt'+this.obj+nodeId+'_reason\')"';
        if(this.config.selectMemberButtonId && this.config.selectMemberButtonId != '') {
          str += 'onclick="select(this,\'';
	  str += node.name;
          str += '\',\'';
          str += this.config.selectMemberButtonId;
	  str += '\')"';
        }
		
	str += '>';
	
        str += '<tr><td valign=center align=center width=20>';
	
	if(node.statusIcon)
		str += '<img id="i' + this.obj + nodeId + '_status" src="' + node.statusIcon + '" alt="" />';
	str += '</td>';
	str += '<td align=center valign=center width="20"> ';

	

	if(this.config.showExpandCollapseIcon == true)  {
		str += this.indent(node, nodeId);
	}


	if (this.config.useIcons) {


//		if (!node.icon) node.icon = (this.root.id == node.pid) ? this.icon.root : ((node._hc) ? this.icon.folder : this.icon.node);


//		if (!node.iconOpen) node.iconOpen = (node._hc) ? this.icon.folderOpen : this.icon.node;


//		if (this.root.id == node.pid && node.icon.indexOf("simple.png") == -1) {
//			node.icon = this.icon.root;
//			node.iconOpen = this.icon.root;
//		}


		str += '<img id="i' + this.obj + nodeId + '" src="' + ((node._io) ? node.iconOpen : node.icon) + '" alt="" />';
	}
	str+='</td><td valign=center align=center style="white-space:nowrap" width="125">';

	if (node.url) {


		str += '<a id="s' + this.obj + nodeId + '" class="' + ((this.config.useSelection) ? ((node._is ? 'nodeSel' : 'node')) : 'node') + '" href="javascript:openGroup(\'' + node.url + '\',\'' + this.config.openGroupButtonId + '\');"';


		if (node.title) str += ' title="' + node.title + '"';


		if (node.target) str += ' target="' + node.target + '"';


		if (this.config.useStatusText) str += ' onmouseover="window.status=\'' + node.name + '\';return true;" onmouseout="window.status=\'\';return true;" ';


		if (this.config.useSelection && ((node._hc && this.config.folderLinks) || !node._hc))


			str += ' onclick="javascript: ' + this.obj + '.s(' + nodeId + ');"';


		str += '>';

	
	}
         if(((node.name).length) <=20){
                str += node.name;
            }
            else{
                str += ((node.name).substring(0,18));
                str +='...';    
            }
	if (node.url || ((!this.config.folderLinks || !node.url) && node._hc)) str += '</a>';
	str += '</div>';

	str += '</td></tr></table>';
     }
	str += '</td></tr>';
     }
        str += '</table>';
	}
	}
	if (node._hc) {


		str += '<div id="d' + this.obj + nodeId + '" class="clip" style="border-width:1px;display:' + ((node._io) ? 'block' : 'none') + ';">';


		str += '<table border=0 cellpadding=0 cellspacing=0>';
		if(node._children > 1 && node.visible && node.pid != -1 && node.name != 'WF_DUMMY_NODE') {
			str += '<tr><td height="9" align="center"><img src="'+this.icon.smallLine+'" alt="" border=0></td></tr>';
		}
		str += '<tr>';
		str += '<td>';


		str += this.addNode(node);


		str += '</td></tr></table>';

		str += '</div>';


	}


	this.aIndent.pop();

	return str;
	

};




dTree.prototype.indent = function(node, nodeId) {


	var str = '';


	(node._ls) ? this.aIndent.push(0) : this.aIndent.push(1);


	if (node._hc)
	{
		str += '<a href="javascript: ' + this.obj + '.o(' + nodeId + ');"><img id="j' + this.obj + nodeId + '" src="';

		str += (node._io) ? this.icon.nlMinus : this.icon.nlPlus;


		str += '" alt="" /></a>';
	}

	return str;
};



dTree.prototype.setCS = function(node) {


	var lastId;

	var children =0;


	for (var n=0; n<this.aNodes.length; n++) {


		if (this.aNodes[n].pid == node.id)
		{
		 node._hc = true;
		 children ++;
		}


		if (this.aNodes[n].pid == node.pid) lastId = this.aNodes[n].id;


	}
	node._children = children;

	if (lastId==node.id) node._ls = true;

	if(node.parallel == 'true' && node._hc && node._children > 1 && node.title == '' && node.name == '' && node.url == '' && node.icon == '') {
		node.visible = false;
    }
};


dTree.prototype.getSelected = function() {


	var sn = this.getCookie('cs' + this.obj);


	return (sn) ? sn : null;


};





dTree.prototype.s = function(id) {


	if (!this.config.useSelection) return;


	var cn = this.aNodes[id];


	if (cn._hc && !this.config.folderLinks) return;


	if (this.selectedNode != id) {


		if (this.selectedNode || this.selectedNode==0) {


			eOld = document.getElementById("s" + this.obj + this.selectedNode);


			eOld.className = "node";


		}


		eNew = document.getElementById("s" + this.obj + id);


		eNew.className = "nodeSel";


		this.selectedNode = id;


		if (this.config.useCookies) this.setCookie('cs' + this.obj, cn.id);


	}


};


dTree.prototype.o = function(id) {


	var cn = this.aNodes[id];


	this.nodeStatus(!cn._io, id, cn._ls);


	cn._io = !cn._io;


	if (this.config.closeSameLevel) this.closeLevel(cn);


	if (this.config.useCookies) this.updateCookie();


};




dTree.prototype.oAll = function(status) {


	for (var n=0; n<this.aNodes.length; n++) {


		if (this.aNodes[n]._hc && this.aNodes[n].pid != this.root.id) {


			this.nodeStatus(status, n, this.aNodes[n]._ls)


			this.aNodes[n]._io = status;


		}


	}


	if (this.config.useCookies) this.updateCookie();


};


dTree.prototype.openTo = function(nId, bSelect, bFirst) {


	if (!bFirst) {


		for (var n=0; n<this.aNodes.length; n++) {


			if (this.aNodes[n].id == nId) {


				nId=n;


				break;


			}


		}


	}


	var cn=this.aNodes[nId];


	if (cn.pid==this.root.id || !cn._p) return;


	cn._io = true;


	cn._is = bSelect;


	if (this.completed && cn._hc) this.nodeStatus(true, cn._ai, cn._ls);


	if (this.completed && bSelect) this.s(cn._ai);


	else if (bSelect) this._sn=cn._ai;


	this.openTo(cn._p._ai, false, true);


};


dTree.prototype.closeLevel = function(node) {


	for (var n=0; n<this.aNodes.length; n++) {


		if (this.aNodes[n].pid == node.pid && this.aNodes[n].id != node.id && this.aNodes[n]._hc) {


			this.nodeStatus(false, n, this.aNodes[n]._ls);


			this.aNodes[n]._io = false;


			this.closeAllChildren(this.aNodes[n]);


		}


	}


}


dTree.prototype.closeAllChildren = function(node) {


	for (var n=0; n<this.aNodes.length; n++) {


		if (this.aNodes[n].pid == node.id && this.aNodes[n]._hc) {


			if (this.aNodes[n]._io) this.nodeStatus(false, n, this.aNodes[n]._ls);


			this.aNodes[n]._io = false;


			this.closeAllChildren(this.aNodes[n]);


		}


	}


}



dTree.prototype.nodeStatus = function(status, id, bottom) {


	eDiv	= document.getElementById('d' + this.obj + id);


	eJoin	= document.getElementById('j' + this.obj + id);


	if (this.config.useIcons) {


		eIcon	= document.getElementById('i' + this.obj + id);


		eIcon.src = (status) ? this.aNodes[id].iconOpen : this.aNodes[id].icon;


	}


	eJoin.src = ((status)?this.icon.nlMinus:this.icon.nlPlus);


	eDiv.style.display = (status) ? 'block': 'none';


};


dTree.prototype.clearCookie = function() {


	var now = new Date();


	var yesterday = new Date(now.getTime() - 1000 * 60 * 60 * 24);


	this.setCookie('co'+this.obj, 'cookieValue', yesterday);


	this.setCookie('cs'+this.obj, 'cookieValue', yesterday);


};


dTree.prototype.setCookie = function(cookieName, cookieValue, expires, path, domain, secure) {


	document.cookie =


		escape(cookieName) + '=' + escape(cookieValue)


		+ (expires ? '; expires=' + expires.toGMTString() : '')


		+ (path ? '; path=' + path : '')


		+ (domain ? '; domain=' + domain : '')


		+ (secure ? '; secure' : '');


};




dTree.prototype.getCookie = function(cookieName) {


	var cookieValue = '';


	var posName = document.cookie.indexOf(escape(cookieName) + '=');


	if (posName != -1) {


		var posValue = posName + (escape(cookieName) + '=').length;


		var endPos = document.cookie.indexOf(';', posValue);


		if (endPos != -1) cookieValue = unescape(document.cookie.substring(posValue, endPos));


		else cookieValue = unescape(document.cookie.substring(posValue));


	}


	return (cookieValue);


};



dTree.prototype.updateCookie = function() {


	var str = '';


	for (var n=0; n<this.aNodes.length; n++) {


		if (this.aNodes[n]._io && this.aNodes[n].pid != this.root.id) {


			if (str) str += '.';


			str += this.aNodes[n].id;


		}


	}


	this.setCookie('co' + this.obj, str);


};



dTree.prototype.isOpen = function(id) {


	var aOpen = this.getCookie('co' + this.obj).split('.');


	for (var n=0; n<aOpen.length; n++)


		if (aOpen[n] == id) return true;


	return false;


};





if (!Array.prototype.push) {


	Array.prototype.push = function array_push() {


		for(var i=0;i<arguments.length;i++)


			this[this.length]=arguments[i];


		return this.length;


	}


};


if (!Array.prototype.pop) {


	Array.prototype.pop = function array_pop() {


		lastElement = this[this.length-1];


		this.length = Math.max(this.length-1,0);


		return lastElement;


	}


};

//findPos function is from http://www.quirksmode.org/js/findpos.html;
//where its workings are explained in more detail.
function findPos(obj) {
	var curleft = curtop = 0;
	if (obj.offsetParent) {
		curleft = obj.offsetLeft
		curtop = obj.offsetTop
		while (obj = obj.offsetParent) {
			curleft += obj.offsetLeft
			curtop += obj.offsetTop
		}
	}
	else if(obj.x || obj.y) {
	  curleft += obj.x;
	  curtop += obj.y;
	}
	return [curleft,curtop];
}

//Display a named menu, at the position of another object
function displayToolTip(parent,named, posx, posy)
{
	//get the named menu
	var menu_element = document.getElementById(named);
	//override the 'display:none;' style attribute
	menu_element.style.display = "";
	//get the placement of the element that invoked the menu...
	//...and put the menu there
	var placement = findPos(parent);
	x = placement[0] + posx;
	y = placement[1] + posy;
	menu_element.style.left = x + "px";
	menu_element.style.top = y + "px";
}

//Hide a named menu
function hideToolTip(named)
{
	//get the named menu
	var menu_element = document.getElementById(named);
	//hide it with a style attribute
	menu_element.style.display = "none";
}


